// Termostato
// www.ilsito.net

#include <RTClib.h>
//#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#include "DHT.h"
#define DHTPIN 5 
#define DHTTYPE DHT11
DHT dht(DHTPIN, DHTTYPE);
RTC_DS1307 rtc;
LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);

float lettura = 0, gradiC = 0;
long trTemp = 0, trOra = 0, trDisp = 0;
int opz = -1, inc_opz = 0, incH = 0, mod_incH = 0, flagH = 0, flagT = 0, t_vecchia = 0, stato = 0, timer = 0;
boolean vett[24] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
int t_luce = 30; // tempo luminosità
int soglia = 20; // soglia di temperatura predefinita
int perQuanto = 0;
unsigned long manAdesso = 0;
unsigned long manInter = millis();
unsigned long manIstante = millis();
int onoff = 0;
int manMinuti = 0;
unsigned long minuto = 60000;
 
//definizione caratteri personalizzati
byte spento[8] = {
  B00000,
  B00000,
  B00000,
  B00000,
  B11011,
  B11011,
  B11011,
  B11011,
};

byte on_pari[8] = {
  B11000,
  B11000,
  B11000,
  B11000,
  B11011,
  B00011,
  B00011,
  B00011,

};

byte on_dispari[8] = {
  B00011,
  B00011,
  B00011,
  B00011,
  B11011,
  B11000,
  B11000,
  B11000,

};

byte on_due[8] = {
  B11011,
  B11011,
  B11011,
  B11011,
  B11011,
};

byte segna_pari[8] = {
  B00000,
  B00000,
  B00000,
  B00000,
  B00000,
  B00000,
  B11000,
  B11000,
};

byte segna_dispari[8] = {
  B00000,
  B00000,
  B00000,
  B00000,
  B00000,
  B00000,
  B00011,
  B00011,
};

void setup() {
  rtc.begin();
  dht.begin();
  //Wire.begin();
  float t = dht.readTemperature();
  float f = dht.readTemperature(true);
  float h = dht.readHumidity();
  float hif = dht.computeHeatIndex(f, h);
  float hic = dht.computeHeatIndex(t, h, false);
  lcd.clear();
  lcd.begin(16, 2);
  lcd.setCursor(0, 0);
  lcd.print("***** CIAO *****");
  lcd.setCursor(1, 1);
  lcd.print("WWW.ILSITO.NET");

  lcd.createChar(0, spento);
  lcd.createChar(1, on_pari);
  lcd.createChar(2, on_dispari);
  lcd.createChar(3, on_due);
  lcd.createChar(4, segna_pari);
  lcd.createChar(5, segna_dispari);

  delay(2000);
  lcd.clear();
  scansione();
  lcd.setCursor(6, 0);
  temperatura();

  //rtc.adjust(DateTime(2017, 31, 10, 17, 35, 55)); //SISTEMO ORA
  
  pinMode(2, INPUT); //menu
  pinMode(3, INPUT); //+
  pinMode(4, INPUT); //-
  pinMode(7, OUTPUT); //RELE
  pinMode(8, OUTPUT); //RELE manuale
  digitalWrite(7, LOW);
  digitalWrite(8, LOW); 
}

void loop() {

  //casi pressione menu
  if (digitalRead(2)) {

    opz = inc_opz % 4;
    switch (opz) {

      case -1:
        lcd.backlight();
        break;
      
      case 0:
        lcd.clear();
        lcd.backlight();
        lcd.setCursor(0, 0);
        lcd.print("Imp. manuale");
        lcd.setCursor(5, 1);
        digitalWrite(7, HIGH);
        lcd.print("spenta");
        onoff = 0;
        perQuanto = 0;
        lcd.backlight();
        break;      
         
      case 1:
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print("Imp. orari");
        lcd.backlight();
        scansione();
        break;

      case 2:
        flagH = 0;
        lcd.clear();
        lcd.setCursor(0, 0);
        lcd.print("Imp. temperatura");
        //lcd.setCursor(0, 1);
        //lcd.print("soglia?  ");
        //temperatura();
        lcd.setCursor(7, 1);
        lcd.print(soglia);
        lcd.backlight();
        break;

      case 3:
        lcd.clear();
        lcd.backlight();
        flagH = 0;
        timer = 0;
        break;
    }
    
    delay(500);
    inc_opz++;
    timer = 0;
  }

  if ((opz == 3) || (opz == -1)) { //siamo fuori dal menu in visualizzazione normale
    scansione();
    lcd.setCursor(0, 0);
    //sistemiamo ora
    if (millis() - trOra > 1000) {
      DateTime now = rtc.now();
      char ora[10];
      sprintf(ora, "%2d:%02d" , now.hour(), now.minute());
      lcd.setCursor(0, 0);
      lcd.print(ora);
      trOra = millis();
    }

    //risparmio energetico spegne la retroilluminazione del display
    if (millis() - trDisp > 1000) {
      timer++;
      trDisp = millis();

    }
    if (timer >= t_luce) {
      lcd.noBacklight();
      inc_opz = -1;
    }

    //sistemiamo temperatura
    if (millis() - trTemp > 2000) { // aggiorna ogni x000 la temperatura
      lcd.setCursor(6, 0);
      temperatura();
    }
    
    DateTime now = rtc.now();

    switch (stato) {
      case 0: //se è spenta

        if (gradiC < soglia && vett[now.hour()]) { //se sono sotto soglia && in orario la accendo
          lcd.setCursor(13, 1);
          lcd.print("ON ");
          digitalWrite(7, LOW);
          lcd.backlight();
          stato = 1;
          //soglia = soglia + 2;
        } else { //altrimenti la tengo spenta
          lcd.setCursor(13, 1);
          lcd.print("OFF");
          digitalWrite(7, HIGH);
          stato = 0;
        }
        
        break;

      case 1:// se è accesa
        if (gradiC > soglia || vett[now.hour()] == 0) { //se sono oltre soglia oppure fuori orario la la spengo
          lcd.setCursor(13, 1);
          lcd.print("OFF");
          digitalWrite(7, HIGH);
          stato = 0;
          //soglia = soglia - 2;
        }
        
        break;
    }


    if (stato == 0) {
      lcd.setCursor(13, 1);
      lcd.print("OFF");
      digitalWrite(7, HIGH);
    }
    else {
      lcd.setCursor(13, 1);
      lcd.print("ON ");
      digitalWrite(7, LOW);
    }
  }

  if (digitalRead(3) && opz == 0 && onoff == 0)
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Imp. manuale");
    lcd.setCursor(5, 1);
    digitalWrite(7, LOW);
    lcd.print("accesa");
    onoff = 1;
    perQuanto = 0;
    lcd.backlight();
    delay(200);    
  }

  if (digitalRead(3) && opz == 0 && onoff == 1)
  {
    lcd.clear();
    lcd.setCursor(0, 0);
    lcd.print("Imp. manuale");
    lcd.setCursor(5, 1);
    digitalWrite(7, HIGH);
    lcd.print("spenta");
    onoff = 0;
    perQuanto = 0;
    lcd.backlight();
    delay(200);
  } 
 
 if (digitalRead(4) && opz == 0)
 {
    
    if (perQuanto >= 5)
    {
       perQuanto = 0;
    } 
    perQuanto++;
    
    if (perQuanto == 1)
    {
      manAdesso = millis();
      minuto = 0;
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("Imp. manuale");
      lcd.setCursor(3, 1);
      lcd.print("minuti 30");
      digitalWrite(7, LOW);
      manMinuti = 30;
      onoff = 0;
      lcd.backlight();
    }

    if (perQuanto == 2)
    {
      manAdesso = millis();
      minuto = 0;
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("Imp. manuale");
      lcd.setCursor(3, 1);
      lcd.print("minuti 45");
      digitalWrite(7, LOW);
      manMinuti = 45;
      onoff = 0;
      lcd.backlight();
    }
 
    if (perQuanto == 3)
    {
      manAdesso = millis();
      minuto = 0;
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("Imp. manuale");
      lcd.setCursor(3, 1);
      lcd.print("minuti 60");
      digitalWrite(7, LOW);
      manMinuti = 60;
      onoff = 0;
      lcd.backlight();
    } 
 
    if (perQuanto == 4)
    {
      manAdesso = millis();
      minuto = 0;
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("Imp. manuale");
      lcd.setCursor(3, 1);
      lcd.print("minuti 90");
      digitalWrite(7, LOW);
      manMinuti = 90;
      onoff = 0;
      lcd.backlight();
    } 
 
    if (perQuanto == 5)
    {
      manAdesso = millis();
      minuto = 0;
      lcd.clear();
      lcd.setCursor(0, 0);
      lcd.print("Imp. manuale");
      lcd.setCursor(3, 1);
      lcd.print("minuti 120");
      digitalWrite(7, LOW);
      manMinuti = 120;
      onoff = 0;
      lcd.backlight();
    }
   
    delay(200);
    timer = 0;
}


  if (digitalRead(3) && opz == 2) //decrementa temperatura alla pressione del tasto -
  {
    soglia--;
    lcd.setCursor(7, 1);
    lcd.print(soglia);
    delay(200);
    if (gradiC < soglia) stato = 0;
    if (gradiC > soglia) stato = 1;
  }


  if (digitalRead(4) && opz == 2) //aumenta temperatura alla pressione del tasto +
  {
    soglia++;
    lcd.setCursor(7, 1);
    lcd.print(soglia);
    delay(200);
    if (gradiC < soglia) stato = 0;
    if (gradiC > soglia) stato = 1;
  }


  if (digitalRead(3) && opz == 1) //scorre cavalieri
  { flagH = 1;
    mod_incH = incH % 24;
    lcd.clear();
    scansione();
    lcd.backlight();

    if (incH % 2 == 0) {
      lcd.setCursor(mod_incH / 2 , 0); // lcd.setCursor(mod_incH / 2 + 2 , 0)
      lcd.write(byte(4));
    }
    
    if (incH % 2 == 1) {
      lcd.setCursor(mod_incH / 2 , 0); // lcd.setCursor(mod_incH / 2 + 2 , 0)
      lcd.write(byte(5));
    }

    delay(200);
    incH++;

  }
  if (digitalRead(4) && opz == 1 && flagH == 1) { //setta cavalieri
    vett[mod_incH] = !vett[mod_incH];
    scansione();
    delay(200);
  }


manIstante = millis();
timerMinuti();

} 

// fine main --------------------------------------------------------------------------------------------------

void temperatura() {
 float t = dht.readTemperature();
 float h = dht.readHumidity();
 gradiC = t - 1;
 lcd.print((int)gradiC);
 lcd.print("c ");
 lcd.print((int)h);
 lcd.print("% ");
 lcd.print(soglia);
 trTemp = millis();
}

void scansione() { //aggiorna i cavalieri
  int i = 0;
  for (i = 0; i < 12; i++) {
    if (vett[i * 2] == 0 && vett[i * 2 + 1] == 0) {
      lcd.setCursor(i + 0, 1); //offset 2 per centrare i caratteri sul display
      lcd.write(byte(0));
    }

    if (vett[i * 2] == 1 && vett[i * 2 + 1] == 0) {
      lcd.setCursor(i + 0, 1); //offset 2 (al posto di 0) per centrare i caratteri sul display
      lcd.write(byte(1));
    }

    if (vett[i * 2] == 0 && vett[i * 2 + 1] == 1) {
      lcd.setCursor(i + 0, 1); //offset 2 (al posto di 0) per centrare i caratteri sul display
      lcd.write(byte(2));
    }

    if (vett[i * 2] == 1 && vett[i * 2 + 1] == 1) {
      lcd.setCursor(i + 0, 1); //offset 2 (al posto di 0) per centrare i caratteri sul display
      lcd.write(byte(3));
    }

  }
}

void timerMinuti(){

  if (manIstante > (manAdesso + minuto) && manMinuti > -1 && perQuanto > 0){
    lcd.setCursor(10, 1);
    lcd.print(manMinuti);
    if(manMinuti < 100){
      lcd.setCursor(12, 1);
      lcd.print(" ");
         if (manMinuti < 10){
           lcd.setCursor(11, 1);
           lcd.print(" ");
         }
     }
    manMinuti = manMinuti - 1;
    minuto = minuto + 60000;
    if (manMinuti == 0){
     digitalWrite(7, HIGH);
     lcd.noBacklight(); 
    }
  }
  
}



